---
title: "Update user role"
description: "Update a user's access level in a project"
---

> Documentation Index
> Fetch the complete documentation index at: https://docs.testandaccept.com/llms.txt
> Use this file to discover all available pages before exploring further.

Path: Test And Accept API › ProjectUsers

`PATCH /projects/{projectId}/users/{userId}/role`

Update a user's access level in a project

## Authentication

- `bearerAuth`, http, header `Authorization`, format `tnda_ token`

## Path parameters

- `projectId` (`projectUsers-updateUserRole.path.projectId`; string, required)
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000)$`
- `userId` (`projectUsers-updateUserRole.path.userId`; string, required)
  - minLength 1

## Request body

_Required._

- `accessLevel` (`projectUsers-updateUserRole.accessLevel`; string, required)
  - one of `"owner"`, `"editor"`, `"approver"`, `"viewer"`, `"follower"`

## Example request

```json
{
  "accessLevel": "owner"
}
```

## Code samples

### cURL

```bash
curl --request PATCH \
  --url 'https://api.testandaccept.com/api/rest/projects/<projectId>/users/<userId>/role' \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "accessLevel": "owner"
}
'
```

### TypeScript

```typescript
const url = 'https://api.testandaccept.com/api/rest/projects/<projectId>/users/<userId>/role';
const options = {
  method: 'PATCH',
  headers: {'Content-Type': 'application/json', Authorization: 'Bearer <token>'},
  body: JSON.stringify({accessLevel: 'owner'})
};

fetch(url, options)
  .then(res => res.json())
  .then(json => console.log(json))
  .catch(err => console.error(err));
```

### Python

```python
import requests

url = "https://api.testandaccept.com/api/rest/projects/<projectId>/users/<userId>/role"

payload = { "accessLevel": "owner" }
headers = {
    "Content-Type": "application/json",
    "Authorization": "Bearer <token>"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.text)
```

## Responses

### 200

Successful response

#### Example

```json
{
  "success": true
}
```

- `success` (`projectUsers-updateUserRole.response.200.success`; boolean, required)

### 400

Invalid input data

#### Example

```json
{
  "code": "BAD_REQUEST",
  "message": "Invalid input data",
  "issues": []
}
```

- `message` (`projectUsers-updateUserRole.response.400.message`; string, required) — The error message
  - example `"Invalid input data"`
- `code` (`projectUsers-updateUserRole.response.400.code`; string, required) — The error code
  - example `"BAD_REQUEST"`
- `issues` (`projectUsers-updateUserRole.response.400.issues`; array<object>, optional) — An array of issues that were responsible for the error
  - example `[]`
  - `message` (`projectUsers-updateUserRole.response.400.issues.message`; string, required)

### 401

Authorization not provided

#### Example

```json
{
  "code": "UNAUTHORIZED",
  "message": "Authorization not provided",
  "issues": []
}
```

- `message` (`projectUsers-updateUserRole.response.401.message`; string, required) — The error message
  - example `"Authorization not provided"`
- `code` (`projectUsers-updateUserRole.response.401.code`; string, required) — The error code
  - example `"UNAUTHORIZED"`
- `issues` (`projectUsers-updateUserRole.response.401.issues`; array<object>, optional) — An array of issues that were responsible for the error
  - example `[]`
  - `message` (`projectUsers-updateUserRole.response.401.issues.message`; string, required)

### 403

Insufficient access

#### Example

```json
{
  "code": "FORBIDDEN",
  "message": "Insufficient access",
  "issues": []
}
```

- `message` (`projectUsers-updateUserRole.response.403.message`; string, required) — The error message
  - example `"Insufficient access"`
- `code` (`projectUsers-updateUserRole.response.403.code`; string, required) — The error code
  - example `"FORBIDDEN"`
- `issues` (`projectUsers-updateUserRole.response.403.issues`; array<object>, optional) — An array of issues that were responsible for the error
  - example `[]`
  - `message` (`projectUsers-updateUserRole.response.403.issues.message`; string, required)

### 404

Not found

#### Example

```json
{
  "code": "NOT_FOUND",
  "message": "Not found",
  "issues": []
}
```

- `message` (`projectUsers-updateUserRole.response.404.message`; string, required) — The error message
  - example `"Not found"`
- `code` (`projectUsers-updateUserRole.response.404.code`; string, required) — The error code
  - example `"NOT_FOUND"`
- `issues` (`projectUsers-updateUserRole.response.404.issues`; array<object>, optional) — An array of issues that were responsible for the error
  - example `[]`
  - `message` (`projectUsers-updateUserRole.response.404.issues.message`; string, required)

### 500

Internal server error

#### Example

```json
{
  "code": "INTERNAL_SERVER_ERROR",
  "message": "Internal server error",
  "issues": []
}
```

- `message` (`projectUsers-updateUserRole.response.500.message`; string, required) — The error message
  - example `"Internal server error"`
- `code` (`projectUsers-updateUserRole.response.500.code`; string, required) — The error code
  - example `"INTERNAL_SERVER_ERROR"`
- `issues` (`projectUsers-updateUserRole.response.500.issues`; array<object>, optional) — An array of issues that were responsible for the error
  - example `[]`
  - `message` (`projectUsers-updateUserRole.response.500.issues.message`; string, required)


Source: https://docs.testandaccept.com/reference/project-users/update-user-role/index.md
